// Extension cleaner.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <malloc.h>
#include <stdlib.h>

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	HKEY tkey;
	DWORD NOKeysInHKCR;
	DWORD LongestKeyName;
	DWORD KeyNameLen, t, tt;
	char * KeyName;
	char ** extnames=NULL;
	char ** typenames=NULL;
	DWORD noen=0, notn=0;
	FILETIME ftime;
	int errval;

	// Collect names

	RegQueryInfoKey(HKEY_CLASSES_ROOT, NULL, NULL, NULL, &NOKeysInHKCR, &LongestKeyName, NULL, NULL, NULL, NULL, NULL, NULL);

	KeyName=(char*)malloc(LongestKeyName+2);

	for(t=0; t<NOKeysInHKCR; t++) {
		KeyNameLen=LongestKeyName+1;
		RegEnumKeyEx(HKEY_CLASSES_ROOT, t, KeyName, &KeyNameLen, NULL, NULL, NULL, &ftime);

		if ( KeyName[0] == '.' ) { // Extension
			noen++;
			extnames=(char**)realloc(extnames, noen * sizeof(char*));
			extnames[noen-1]=(char*)malloc(KeyNameLen+1);
			strcpy(extnames[noen-1], KeyName);
		} else if ( KeyName[0] != '*' && stricmp(KeyName, "CLSID") != 0 ) { // Type identifier
			notn++;
			typenames=(char**)realloc(typenames, notn * sizeof(char*));
			typenames[notn-1]=(char*)malloc(KeyNameLen+1);
			strcpy(typenames[notn-1], KeyName);
		}
	}

	// Clean up extensions

	char ** unreftypes;
	char valdata[1025];
	DWORD valtype;
	DWORD cbvaldata;
	bool notfound;
	int deletedextensions=0;
	int deletedtypes=0;
	HKEY ttkey;

	unreftypes=(char**)malloc(notn * sizeof(char*));
	memcpy(unreftypes, typenames, sizeof(char*) * notn);

	for(t=0; t<noen; t++) {
		RegOpenKey(HKEY_CLASSES_ROOT, extnames[t], &tkey);
		
		cbvaldata=1024;
		errval=RegQueryValueEx(tkey,"", NULL, &valtype, (BYTE*)valdata, &cbvaldata);
		
		RegCloseKey(tkey);

		if( valtype != REG_SZ || errval != ERROR_SUCCESS ) {
			RegDeleteKey(HKEY_CLASSES_ROOT, extnames[t]);
			deletedextensions++;
		} else {
			notfound=true;
			for(tt=0; tt<notn && notfound; tt++) {
				if ( stricmp(typenames[tt], valdata) == 0 ) {
					unreftypes[tt]=NULL;
					notfound=false;
					break;
				}
			}
			if ( notfound ) {
				RegDeleteKey(HKEY_CLASSES_ROOT, extnames[t]);
				deletedextensions++;
			}
		}
	}

	for(t=0; t<notn; t++) {
		if ( unreftypes[t] != NULL ) {
			RegOpenKey(HKEY_CLASSES_ROOT, unreftypes[t], &tkey);
			cbvaldata=1024;
			if ( stricmp(unreftypes[t], "Unknown") ) {
				if ( RegQueryValueEx(tkey, "EditFlags", NULL, &valtype, (BYTE*)valdata, &cbvaldata) != ERROR_SUCCESS ) {
					if ( RegOpenKey(tkey, "CLSID", &ttkey) != ERROR_SUCCESS ) {
						if ( unreftypes[t][0] != 0 ) {
							if ( RegOpenKey(tkey, "DefaultIcon", &ttkey) == ERROR_SUCCESS || RegOpenKey(tkey, "shell", &ttkey) == ERROR_SUCCESS ) {
								RegDeleteKey(HKEY_CLASSES_ROOT, unreftypes[t]);
								deletedtypes++;
							}
						}
					}
				}
			}
		}
	}

	// Clean up

	free(KeyName);

	for(t=0; t<noen; t++) {
		free(extnames[t]);
	}
	for(t=0; t<notn; t++) {
		free(typenames[t]);
	}

	free(extnames);
	free(typenames);
	free(unreftypes);

	// Show results

	char temp[200];
	char iatemp[20];
	strcpy(temp, "Extensions deleted: ");
	strcat(temp, _itoa(deletedextensions, iatemp, 10));
	strcat(temp, "\nTypes deleted: ");
	strcat(temp, _itoa(deletedtypes, iatemp, 10));

	MessageBox(NULL, temp, "Results", MB_OK);

	return 0;
}



